<?php

class pisol_dtt_option_date{

    private $setting = array();

    private $active_tab;

    private $this_tab = 'date';

    private $tab_name = "Date setting";

    private $setting_key = 'pisol_dtt_date';

    function __construct(){

        $this->active_tab = (isset($_GET['tab'])) ? $_GET['tab'] : 'default';

        $this->settings = array(
                array('field'=>'pi_delivery_days', 'label'=>__('We do delivry on this days','pisol-dtt'),'desc'=>'If you deliver on all days then dont select any thing, if you do on specific days then select those days, you can do multiple selection by pressing CTRL+ mouse click', 'type'=>'multiselect', 'required'=>'required', 'multiple'=>'multiple', 'value'=>array('0'=>__('Sonday','pisol-dtt'), '1'=>__('Monday','pisol-dtt'), '2'=>__('Tuesday','pisol-dtt'), '3'=>__('Wednesday','pisol-dtt'), '4'=>__('Thursday','pisol-dtt'), '5'=>__('Friday','pisol-dtt'), '6'=>__('Saturday','pisol-dtt') )), 
                array('field'=>'pi_pickup_days', 'label'=>__('We do pickup on this days','pisol-dtt'), 'desc'=>'If you pickup on all days then dont select any thing, if you do on specific days then select those days, you can do multiple selection by pressing CTRL+ mouse click', 'type'=>'multiselect', 'required'=>'required', 'multiple'=>'multiple', 'value'=>array('0'=>__('Sonday','pisol-dtt'), '1'=>__('Monday','pisol-dtt'), '2'=>__('Tuesday','pisol-dtt'), '3'=>__('Wednesday','pisol-dtt'), '4'=>__('Thursday','pisol-dtt'), '5'=>__('Friday','pisol-dtt'), '6'=>__('Saturday','pisol-dtt') )), 
            );
        

        if($this->this_tab == $this->active_tab){
            add_action('pisol_dtt_tab_content', array($this,'tab_content'));
        }

        add_action('pisol_dtt_tab', array($this,'tab'),1);

        add_action( 'admin_enqueue_scripts', array($this,'admin_script_date_time') );
        
         

        $this->register_settings();
    }

    function register_settings(){   

        foreach($this->settings as $setting){
                register_setting( $this->setting_key, $setting['field']);
        }
    
    }

    function tab(){
        ?>
        <a class="nav-tab <?php echo $this->active_tab == $this->this_tab || '' ? 'nav-tab-active' : ''; ?>" href="<?php echo admin_url( 'admin.php?page='.$_GET['page'].'&tab='.$this->this_tab ); ?>">
            <?php _e( $this->tab_name, 'pisol-dtt' ); ?> 
        </a>
        <?php
    }

    function tab_content(){
       ?>
        <form method="post" action="options.php"  class="pisol-setting-form">
        <?php settings_fields( $this->setting_key ); ?>
        <div class="pisol_grid">
        <?php
            foreach($this->settings as $setting){
                new pisol_dtt_class_form($setting, $this->setting_key);
            }
        ?>
        </div>
        <?php submit_button(); ?>
        </form>
       <?php
    }

    function admin_script_date_time(){
        wp_enqueue_style('pi_dtt_timepicker', plugins_url('css/jquery.timepicker.min.css', __FILE__));
    
        wp_enqueue_script( 'jquery-ui-datepicker' );
        wp_enqueue_script( 'jquery-ui-timepicker', plugins_url('js/jquery.timepicker.min.js', __FILE__) );
    
        wp_enqueue_style( 'jquery-ui',  plugins_url('css/jquery-ui.css', __FILE__));
        wp_enqueue_script( 'pi-dtt-custom',plugins_url('admin/js/custom.js', __FILE__) );
    }

   
}

/* if we have pro version setting for time tab then we can disable this */
add_action('pisol_dtt_option', new pisol_dtt_option_date(),3);


add_action( 'wp_enqueue_scripts', 'pisol_dtt_date_add_scripts' );

function pisol_dtt_date_add_scripts(){
    if (  is_checkout() ) {

        $pi_delivery_days = get_option('pi_delivery_days','all');
        $pi_pickup_days = get_option('pi_pickup_days','all');
        $pi_preorder_days = abs(get_option('pi_preorder_days', 10));

        wp_enqueue_script( 'jquery-ui-datepicker' );
        // You need styling for the datepicker. For simplicity I've linked to Google's hosted jQuery UI CSS.
        wp_enqueue_style( 'jquery-ui',  plugins_url('css/jquery-ui.css', __FILE__));

        
        $delivery_date = '
            jQuery(function($){
               
                $("#pi_delivery_date").datepicker({
                    minDate: 0,
                    maxDate: "'.$pi_preorder_days.'+D",
                    beforeShowDay: function(date){ 
                        var delivery_days = '.json_encode($pi_delivery_days).';
                        var pickup_days = '.json_encode($pi_pickup_days).';
                        if($("#pi_delivery_type_pickup").is(":checked")){
                            if(pickup_days.indexOf(date.getDay().toString()) == -1){
                                if(pickup_days != ""){
                                    return [false,""]; 
                                }else{
                                    return [true,""];
                                }
                            }else{
                                return [true,""]; 
                            }
                        }else{
                            if(delivery_days.indexOf(date.getDay().toString()) == -1){
                                if(delivery_days != ""){
                                    return [false,""]; 
                                }else{
                                    return [true,""];
                                } 
                            }else{
                                return [true,""]; 
                            }
                        }
                        
                    }
                });
            });
            ';
            wp_add_inline_script('jquery-ui-datepicker', $delivery_date);
    }
}