<?php

class pisol_dtt_option_time{

    private $setting = array();

    private $active_tab;

    private $this_tab = 'time';

    private $tab_name = "Time setting";

    private $setting_key = 'pisol_dtt_time';

    function __construct(){

        $this->active_tab = (isset($_GET['tab'])) ? $_GET['tab'] : 'default';

        $this->settings = array(
                array('field'=>'pi_delivery_start_time', 'label'=>__('Delivery start time','pisol-dtt'), 'type'=>'text', 'required'=>'required', 'readonly'=>'readonly'), 
                array('field'=>'pi_delivery_end_time', 'label'=>__('Delivery end time','pisol-dtt'), 'type'=>'text', 'required'=>'required', 'readonly'=>'readonly') , 
                array('field'=>'pi_pickup_start_time', 'label'=>__('Pickup start time','pisol-dtt'), 'type'=>'text', 'required'=>'required', 'readonly'=>'readonly'), 
                array('field'=>'pi_pickup_end_time', 'label'=>__('Pickup end time','pisol-dtt'), 'type'=>'text', 'required'=>'required', 'readonly'=>'readonly') ,
            );
        

        if($this->this_tab == $this->active_tab){
            add_action('pisol_dtt_tab_content', array($this,'tab_content'));
        }

        add_action('pisol_dtt_tab', array($this,'tab'),1);

        add_action( 'admin_enqueue_scripts', array($this,'admin_script_date_time') );
        
         

        $this->register_settings();
    }

    function register_settings(){   

        foreach($this->settings as $setting){
                register_setting( $this->setting_key, $setting['field']);
        }
    
    }

    function tab(){
        ?>
        <a class="nav-tab <?php echo $this->active_tab == $this->this_tab || '' ? 'nav-tab-active' : ''; ?>" href="<?php echo admin_url( 'admin.php?page='.$_GET['page'].'&tab='.$this->this_tab ); ?>">
            <?php _e( $this->tab_name, 'pisol-dtt' ); ?> 
        </a>
        <?php
    }

    function tab_content(){
       ?>
        <form method="post" action="options.php"  class="pisol-setting-form">
        <?php settings_fields( $this->setting_key ); ?>
        <div class="pisol_grid">
        <?php
            foreach($this->settings as $setting){
                new pisol_dtt_class_form($setting, $this->setting_key);
            }
        ?>
        </div>
        <?php submit_button(); ?>
        </form>
       <?php
    }

    function admin_script_date_time(){
        wp_enqueue_style('pi_dtt_timepicker', plugins_url('css/jquery.timepicker.min.css', __FILE__));
    
        wp_enqueue_script( 'jquery-ui-datepicker' );
        wp_enqueue_script( 'jquery-ui-timepicker', plugins_url('js/jquery.timepicker.min.js', __FILE__) );
    
        wp_enqueue_style( 'jquery-ui',  plugins_url('css/jquery-ui.css', __FILE__));
        wp_enqueue_script( 'pi-dtt-custom',plugins_url('admin/js/custom.js', __FILE__) );
    }

   
}

/* if we have pro version setting for time tab then we can disable this */
add_action('pisol_dtt_option', new pisol_dtt_option_time(),2);


add_action( 'wp_enqueue_scripts', 'pisol_dtt_time_add_scripts' );

function pisol_dtt_time_add_scripts(){
    if (  is_checkout() ) {

        $pi_delivery_start_time = get_option('pi_delivery_start_time','9:00 AM');
        $pi_delivery_end_time = get_option('pi_delivery_end_time','9:00 PM');
        $pi_pickup_start_time = get_option('pi_pickup_start_time','9:00 AM');
        $pi_pickup_end_time = get_option('pi_pickup_end_time','9:00 PM');
        $pi_default_type = get_option('pi_default_type','delivery');
        $pi_time_format = get_option('pi_time_format','h:m p');
        
        wp_enqueue_script( 'jquery-ui-timepicker', plugins_url('js/jquery.timepicker.min.js', __FILE__), array('jquery') );
        wp_enqueue_style('pi_dtt_timepicker', plugins_url('css/jquery.timepicker.min.css', __FILE__));

        $delivery_date = '
        jQuery(function($){
            $("#pi_delivery_time").timepicker({
                interval:15,
                timeFormat:"'.$pi_time_format.'",
                minTime: "'.$pi_delivery_start_time.'",
                maxTime: "'.$pi_delivery_end_time.'"
            });

            $("#pi_delivery_type_pickup, #pi_delivery_type_delivery").on("change", function(){
                var value = $(this).val();
                
                if(value == "pickup"){
                    pi_set_timing("pickup");
                    
                }else{
                    pi_set_timing("delivery");
                }
            });

            pi_set_timing("'.$pi_default_type.'");
        });

        

        function pi_set_timing(type){
            var $ = jQuery;
            if(type == "pickup"){
                $("#pi_delivery_time").timepicker("option","minTime","'.$pi_pickup_start_time.'");
                $("#pi_delivery_time").timepicker("option","maxTime","'.$pi_pickup_end_time.'");
                console.log(type);
            }else{
                $("#pi_delivery_time").timepicker("option","minTime","'.$pi_delivery_start_time.'");
                $("#pi_delivery_time").timepicker("option","maxTime","'.$pi_delivery_end_time.'");
                console.log(type);
            }
        }
        ';
        wp_add_inline_script('jquery-ui-timepicker', $delivery_date);
    }
}