<?php

class pisol_dtt_option{

    private $setting = array();

    private $active_tab;

    private $this_tab = 'default';

    private $tab_name = "General setting";

    private $setting_key = 'pisol_dtt_default';

    function __construct(){

        $this->active_tab = (isset($_GET['tab'])) ? $_GET['tab'] : 'default';

        $this->settings = array(
                array('field'=>'pi_type', 'label'=>__('Enable delivery or pickup option','pisol-dtt'),'desc'=> 'This add or removes pickup or delivery option from the front end', 'type'=>'select', 'value'=>array(false =>__('No','pisol-dtt'), true=>__('Yes','pisol-dtt')), 'default'=>true), 
                array('field'=>'pi_datetime', 'label'=>__('Enable delivery date and time','pisol-dtt'),'desc'=>'Enable or disable pickup delivery date and time option from front end', 'type'=>'select', 'value'=>array(false=>__('No','pisol-dtt'), true=>__('Yes','pisol-dtt')), 'default'=>true),  
                array('field'=>'pi_preorder_days', 'label'=>__('Preorder days','pisol-dtt'), 'desc'=>'How many days ahead a delivery or pickup date can be set', 'type'=>'number', 'default'=>10, 'min'=> 0, 'max'=> apply_filters('pi_max_preorder_date',10)),
                array('field'=>'pi_pickup_label', 'label'=>__('Pickup label','pisol-dtt'), 'desc'=>'The text that will be shown on the pickup button on the checkout page', 'type'=>'text', 'default'=>__('Pickup','pisol-dtt')),
                array('field'=>'pi_delivery_label', 'label'=>__('Delivery label','pisol-dtt'), 'desc'=>'The text that will be shown on the delivery button on the checkout page', 'type'=>'text', 'default'=>__('Delivery','pisol-dtt')),
                array('field'=>'pi_default_type', 'label'=>__('Default Delivery Type','pisol-dtt'),'desc'=>'When user go to checkout page this will be the defualt selected delivery type', 'type'=>'select', 'value'=>array('delivery' =>__('Delivery','pisol-dtt'), 'pickup'=>__('Pickup','pisol-dtt')), 'default'=>'delivery'), 
                array('field'=>'pi_time_format', 'label'=>__('Time Format','pisol-dtt'),'desc'=>'Time format to use 12 hr or 24 hr time format', 'type'=>'select', 'value'=>array('h:m p' =>__('12HR (1:30 PM)','pisol-dtt'), 'H:m'=>__('24HR (13:30)','pisol-dtt'), 'H:m p'=>__('24HR with AM PM (13:30 PM)','pisol-dtt')), 'default'=>'h:m p'), 
            );
        

        if($this->this_tab == $this->active_tab){
            add_action('pisol_dtt_tab_content', array($this,'tab_content'));
        }

        add_action('pisol_dtt_tab', array($this,'tab'),1);
        
        $this->register_settings();
    }

    function register_settings(){   

        foreach($this->settings as $setting){
                register_setting( $this->setting_key, $setting['field']);
        }
    
    }

    function tab(){
        ?>
        <a class="nav-tab <?php echo $this->active_tab == $this->this_tab || '' ? 'nav-tab-active' : ''; ?>" href="<?php echo admin_url( 'admin.php?page='.$_GET['page'].'&tab='.$this->this_tab ); ?>">
            <?php _e( $this->tab_name, 'pisol-dtt' ); ?> 
        </a>
        <?php
    }

    function tab_content(){
       ?>
        <form method="post" action="options.php"  class="pisol-setting-form">
        <?php settings_fields( $this->setting_key ); ?>
        <div class="pisol_grid">
        <?php
            foreach($this->settings as $setting){
                new pisol_dtt_class_form($setting, $this->setting_key);
            }
        ?>
        </div>
        <?php submit_button(); ?>
        </form>
       <?php
    }
}

add_action('pisol_dtt_option', new pisol_dtt_option());